pcl::RandomSample< pcl::PCLPointCloud2 > Class Template Reference
Module filters

RandomSample applies a random sampling with uniform probability. More...

`#include <pcl/filters/random_sample.h>`

Inheritance diagram for pcl::RandomSample< pcl::PCLPointCloud2 >:

## Public Types

typedef boost::shared_ptr< RandomSample< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const RandomSample< pcl::PCLPointCloud2 > > | ConstPtr
Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
typedef boost::shared_ptr< Filter< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const Filter< pcl::PCLPointCloud2 > > | ConstPtr
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef boost::shared_ptr< PCLPointCloud2 > | PCLPointCloud2Ptr
typedef boost::shared_ptr< PCLPointCloud2 const > | PCLPointCloud2ConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| RandomSample ()
| Empty constructor. More...
void | setSample (unsigned int sample)
| Set number of indices to be sampled. More...
unsigned int | getSample ()
| Get the value of the internal sample parameter. More...
void | setSeed (unsigned int seed)
| Set seed of random function. More...
unsigned int | getSeed ()
| Get the value of the internal seed parameter. More...
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
virtual void | filter (PCLPointCloud2 &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PCLPointCloud2ConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output)
| Sample of point indices into a separate PointCloud. More...
void | applyFilter (std::vector< int > &indices)
| Sample of point indices. More...
float | unifRand ()
| Return a random number fast using a LCG (Linear Congruential Generator) algorithm. More...
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

unsigned int | sample_
| Number of indices that will be returned. More...
unsigned int | seed_
| Random number seed. More...
Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Detailed Description

### template<>
class pcl::RandomSample< pcl::PCLPointCloud2 >

RandomSample applies a random sampling with uniform probability.

Author
  Justin Rosen

Definition at line 155 of file random_sample.h.

## Member Typedef Documentation

## ConstPtr

typedef boost::shared_ptr<const RandomSample<pcl::PCLPointCloud2> > pcl::RandomSample< pcl::PCLPointCloud2 >::ConstPtr

Definition at line 167 of file random_sample.h.

## Ptr

typedef boost::shared_ptr<RandomSample<pcl::PCLPointCloud2> > pcl::RandomSample< pcl::PCLPointCloud2 >::Ptr

Definition at line 166 of file random_sample.h.

## Constructor & Destructor Documentation

## RandomSample()

pcl::RandomSample< pcl::PCLPointCloud2 >::RandomSample | ( |  | ) |

inline

Empty constructor.

Definition at line 170 of file random_sample.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::RandomSample< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  output | the resultant point cloud

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::RandomSample< pcl::PCLPointCloud2 >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Sample of point indices.

Parameters

  indices | the resultant point cloud indices

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## getSample()

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::getSample | ( |  | ) |

inline

Get the value of the internal sample parameter.

Definition at line 187 of file random_sample.h.

References pcl::RandomSample< PointT >::sample_.

## getSeed()

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::getSeed | ( |  | ) |

inline

Get the value of the internal seed parameter.

Definition at line 204 of file random_sample.h.

References pcl::RandomSample< PointT >::seed_.

## setSample()

void pcl::RandomSample< pcl::PCLPointCloud2 >::setSample | ( | unsigned int | sample | ) |

inline

Set number of indices to be sampled.

Parameters

  sample |

Definition at line 179 of file random_sample.h.

References pcl::RandomSample< PointT >::sample_.

Referenced by pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::addPointCloud_and_genLOD(), and pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryBBIncludes_subsample().

## setSeed()

void pcl::RandomSample< pcl::PCLPointCloud2 >::setSeed | ( | unsigned int | seed | ) |

inline

Set seed of random function.

Parameters

  seed |

Definition at line 196 of file random_sample.h.

References pcl::RandomSample< PointT >::seed_.

## unifRand()

float pcl::RandomSample< pcl::PCLPointCloud2 >::unifRand | ( |  | ) |

inline protected

Return a random number fast using a LCG (Linear Congruential Generator) algorithm.

See http://software.intel.com/en-us/articles/fast-random-number-generator-on-the-intel-pentiumr-4-processor/ for more information.

Definition at line 232 of file random_sample.h.

## Member Data Documentation

## sample_

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::sample_

protected

Number of indices that will be returned.

Definition at line 212 of file random_sample.h.

## seed_

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::seed_

protected

Random number seed.

Definition at line 214 of file random_sample.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/random_sample.h